const int pinYaw=3;
const int pinRoll=2;

const float tuneYawZero=507;           
const float tuneYawGainDeg=-0.608;
const float tuneYawGainG=tuneYawGainDeg/90;

const float tuneRollZero=509;          
const float tuneRollGainDeg=0.604;
const float tuneRollGainG=tuneRollGainDeg/90;

const int shockTest=45;


// Roll + means Right side up
// Roll - means Left side up
// Yaw + means Nose up
// Yaw - means Tail up





/////////

int accGetYaw5m(){
  int v=accGetYaw(250);
  return v;
}


int accGetYaw(int sNumber){
  //100 is enought to filter out motor vibration
  //10 minimum filter to obtain decent reading during motors activity
  if (sNumber==0){
    return (int)(analogRead(pinYaw)-tuneYawZero)*tuneYawGainDeg;
  }else{
    long sum=0;
    for(int t=0;t<sNumber;t++){
      sum=sum+analogRead(pinYaw);    
      delayMicroseconds (20);
    }
    return (int)  (sum/sNumber-tuneYawZero)*tuneYawGainDeg; 
  }

}









int accGetRawYaw(){
  return analogRead(pinYaw); 
}
//////////







/////////
int accGetRoll5m(){
  int v=accGetRoll(250);
  return v;
}


int accGetRoll(int sNumber){
  //100 is enought to filter out motor vibration
  //10 minimum filter to obtain decent reading during motors activity
  if (sNumber==0){
    return (int)(analogRead(pinRoll)-tuneRollZero)*tuneRollGainDeg;
  }else{
    long sum=0;
    for(int t=0;t<sNumber;t++){
      sum=sum+analogRead(pinRoll);    
      delayMicroseconds (20);
    }
    return (int)  (sum/sNumber-tuneRollZero)*tuneRollGainDeg; 
  }

}


int accGetRawRoll(){
  return analogRead(pinRoll); 
}
/////////








//////
boolean accIsShock(){
  boolean shock=accGetShock();
  if (shock>shockTest){return true;}else{return false;}
}



int accGetShock(){//50ms
  int delta=0;
  long oldBase=0;
  int maxDelta=0;
  int minVal=0;
  boolean st=true;
  
  for (int s=0;s<10;s++){//valuta 10 delta basati su segnali filtrati
  
      //passa basso - integratore-----------------------
      //ottiene la media di 25 letture
      //obiettivo: scartare il rumore dei motori
       long base=0;
       for(int t=0;t<255;t++){
         base=base+analogRead(pinYaw);    
         delayMicroseconds(20); 
       }
       base=base/100;
       
       
       //passa alto - derivatore------------------------
       //obiettivo: registrare il delta dalla lettura precedente
       delta=abs(base-oldBase);
       oldBase=base;   
       
       
       //latch------------------------------------------
       //obiettivo: tenere traccia del massimo delta verificatosi nel loop 
       if (st){
         st=false;
       }
       else{
         if (delta>maxDelta){maxDelta=delta;}
       }   
  }
  return maxDelta;
}








void accTest (){
    //int yaw=accGetYaw(0);
    //int yaw10=accGetYaw(10);
    int yaw50=accGetYaw(0);
    //int yaw60=accGetYaw(60);
    //int yaw100=accGetYaw(100);
    //int shock=accGetShock();
    //float acc=accGetYawG();
    //int roll=accGetRoll();
    Serial.println(yaw50);

 
}
